/*
btopent.c - Release 0.1.0  Btree create temporary database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

#define BTOPENT 300

btreefmt *btopent(int nodesz, int rcdlen, int keylen,
   int keyofst, int dletofst,
   int *reason, unsigned char *seed)
   {
   int rslt;
   unsigned char *p,*q,*r;
   char *dbnptr,*dbnptrend;
   unsigned char *dbnseed;
   char dbname[32];
   *reason = 0;
   if (seed == NULL)
      {
      dbnseed = (unsigned char *) rndinit();
      if (dbnseed == NULL)
         {
         fprintf(stderr,"btopent: rndinit error\n");
         *reason = BTREE_ERR + BTOPENT + 1;
         return(NULL);
         } /* rndinit error */
      } /* if seed pointer missing */
   else
      {
      dbnseed = (unsigned char *)
         malloc(RND_BYTE + 17);
      if (dbnseed == NULL)
         {
         fprintf(stderr,"btopent: "
            "out of memory\n");
         *reason = BTREE_ERR + BTOPENT + 2;
         return(NULL);
         } /* out of mem */
      p = (unsigned char *) seed;
      q = (unsigned char *) p + RND_BYTE + 1;
      r = (unsigned char *) dbnseed;
      while (p < q) *r++ = *p++;
      } /* if real seed pointer */
   dbnptr    = (char *) dbname;
   dbnptrend = (char *) dbnptr + 8;
   while (dbnptr < dbnptrend)
      {
      *dbnptr++ = rndnum(26,dbnseed) + 'A';
      } /* for each char in basename */
   free(dbnseed);
   *dbnptr++ = '\0';
   strcat(dbname,".BT");
   rslt = btinit(dbname,INITNEW,nodesz,
      rcdlen,keylen,keyofst,dletofst);
   if (rslt)
      {
      fprintf(stderr,"btopent: btinit error\n");
      *reason = rslt;
      return(NULL);
      } /* init err */
   /* reason is an output parameter */
   /* in btopen */
   return(btopen(dbname,UPDT,reason));
   } /* btopent */
