/*
bldbt.c Version 0.1.0  Btree build test database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: bldbt filename */

#include <bthash.h>

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage:   %s "
      "filename #records\n", pgm);
   fprintf(stderr,"Example: %s "
      "test.bt 100\n", pgm);
   fprintf(stderr,"#records is 1 - 999999\n");
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int opnerr;
   int lmt;
   int i;
   int rslt;
   btreefmt *bthdr;
   unsigned char *rndSeed;
   unsigned char *p,*q;
   unsigned char *rcdptr;
   unsigned char str[4096];
   unsigned char dbname[256];
   if (argc != 3) putstx(*argv);
   strcpy((char *) dbname,*(argv+1));
   lmt = (int) atoi(*(argv+2));
   if (lmt < 1 || lmt > 999999) putstx(*argv);

   rndSeed = (unsigned char *) rndinit();
   if (rndSeed == NULL)
      {
      fprintf(stderr,"bldbt: rndinit error\n");
      exit(1);
      } /* if rndinit failed */

   bthdr = (btreefmt *) btopen((char *) dbname,
      UPDT,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"bldbt: btopen "
         "error %d\n", opnerr);
      free(rndSeed);
      exit(1);
      } /* open error */
   /* process starts here */

   rslt = 0;
   i = lmt;
   while (!rslt && (i--))
      {
      p = (unsigned char *) str;
      q = (unsigned char *) p + bthdr->keyofst;
      while (p < q)
	 {
         *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in rcd */
      q = (unsigned char *) p + bthdr->keylen;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'A';
	 } /* for each char in rcd */
      q = (unsigned char *) str + bthdr->rcdlen;
      while (p < q)
	 {
         *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in rcd */
      *p = '\0';
      rcdptr = (unsigned char *) str;
      rslt = btisrt(bthdr,ROOT,rcdptr);
      if (rslt)
	 {
	 fprintf(stderr,"after btisrt: rslt %d\n",
	    rslt);
	 exit(1);
	 } /* btisrt err */
      } /* insert loop */

   /**********************************************************/
   btclose(bthdr);
   return(0);
   } /* main */
